﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using EscolaMVC.Models;
using EscolaMVC.Entitats;
using WebMatrix.WebData;


namespace EscolaMVC.Controllers
{
    [Authorize(Roles="Administratius, Administradors")]
    public class AdminController : Controller
    {
        //
        // GET: /Admin/

        public ActionResult Index()
        {
            GestioUsuarisModel gum = new GestioUsuarisModel();
            gum.UsuariPassword = new UsuariPasswordModel();
            gum.CercaUsuaris = new CercaUsuarisModel();
            return View(gum);
        }

        [HttpPost]
        public ActionResult CanviarPassword(UsuariPasswordModel model)
        {   
            string usuari = model.UserName;
            string password = model.Contrasenya;
            EscolaMVC.Services.GestioUsuaris gu = new Services.GestioUsuaris();
            string error = string.Empty;
            if (
                gu.ResetPassword(usuari, password, out error)) {
                    model.Estat = "Contrasenya canviada.";
            }
            else {
                model.Estat = error;
            }
            //string token = WebSecurity.GeneratePasswordResetToken(usuari);
            //WebSecurity.ResetPassword(token, password);
            
            
            GestioUsuarisModel vm = new GestioUsuarisModel();
            vm.CercaUsuaris = new CercaUsuarisModel();
            vm.UsuariPassword = model;
            return View("Index",vm);
        }
        [HttpPost]
        public ActionResult CercarUsuaris(CercaUsuarisModel model)
        {
            string usuari = model.Usuari;
            string dni = model.DNI;
            string nom = model.Nom;
            string cognoms = model.Cognoms;
            string tipus = model.Tipus;
            GestioUsuarisModel vm = new GestioUsuarisModel();
            vm.CercaUsuaris = model;
            vm.UsuariPassword = new UsuariPasswordModel();
            if (ModelState.IsValid)
            {   
                IEnumerable<UsuariModel> resultats;
                CercaUsuarisDb cercador = new CercaUsuarisDb();
                resultats = cercador.cercaUsuaris(usuari, dni, nom, cognoms, tipus);
                vm.CercaUsuaris.Usuaris = resultats;
            }
            return View("Index", vm);
        }

    }
}
