﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web;
using System.Web.Http;
using EscolaMVC.Entitats;

namespace EscolaMVC.Controllers
{
    
    public class AutoCompleteController : ApiController
    {
        private EscolaEntities db = new EscolaEntities();

        public class AlumneDTO
        {
            public int value;
            public string label;
        }

        /// <summary>
        /// Retorna el conjunt d'alumnes consumible per jQuery AutoComplete.
        /// </summary>
        /// <param name="term">Parametre de cerca.</param>
        /// <returns></returns>
        [HttpGet]
        public IEnumerable<AlumneDTO> GetNomsIdAlumnesDTO(string term)
        {
            var alumnes = from alumne in db.Alumne.AsNoTracking()
                          where ((alumne.Nom + " " + alumne.Cognoms).Contains(term))
                          select new
                          {
                              Id = alumne.Id,
                              Nia = alumne.NIA,
                              NomiCognoms = alumne.Nom + " " + alumne.Cognoms
                          };
            IEnumerable<AlumneDTO> alumnesDTO = alumnes.AsEnumerable().Select(alumne => new AlumneDTO { value = alumne.Id, label = alumne.Nia + " " + alumne.NomiCognoms });
            return alumnesDTO;

        
        }

        protected override void Dispose(bool disposing)
        {
            db.Dispose();
            base.Dispose(disposing);
        }
    }

}
