﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using EscolaMVC.Models;
using EscolaMVC.Entitats;

namespace EscolaMVC.Controllers
{
    [Authorize(Roles="Administradors")]
    public class EscolaController : Controller
    {
        private readonly IEscolaSingleTonRepository escolaRepository;

        
        public EscolaController() : this(new EscolaSingleTonRepository()) 
        { 
        }
        
        public EscolaController(IEscolaSingleTonRepository escolaRepository) {
            this.escolaRepository = escolaRepository;
        }
        
        //
        // GET: /Escola/
        public ActionResult Index()
        {
            Escola c = this.escolaRepository.Escola;
            return View(c);
        }
        [HttpPost]
        public ActionResult Index(Escola escola)
        {
            if (!this.escolaRepository.Insert(escola) || !this.escolaRepository.Save()) {
                ViewBag.Error = escolaRepository.Error;
            }
            return View(escola);
        }

        //
        // GET: /Escola/Edit/5

        public ActionResult Edit()
        {
            Escola c = this.escolaRepository.Escola;
            return View(c);
        }

        //
        // POST: /Escola/Edit/5

        [HttpPost]
        public ActionResult Edit(Escola escola)
        {
            if (!this.escolaRepository.Update(escola) || !this.escolaRepository.Save())
            {
                ViewBag.Error = escolaRepository.Error;
                return View();
            }
            else {
                return RedirectToAction("Index");
            }
            
        }
       
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                escolaRepository.Dispose();
            }
            base.Dispose(disposing);
        }
    }
}
