﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using EscolaMVC.Models;
using EscolaMVC.Entitats;
using EscolaMVC.Services;

namespace EscolaMVC.Controllers
{
    [Authorize(Roles="Pares")]
    public class PortalParesController : Controller
    {   
        PortalPares portalParesDomini;
        
        
        public PortalParesController() {
            this.portalParesDomini = new PortalPares();
        }        

        public ActionResult Index()
        {   

            PortalParesViewModel portalpares = portalParesDomini.getPortalPares(UserName);
            if (!portalpares.TeFills) return View("UsuariNoPare");
            return View(portalpares);
        }

        
        public ActionResult Citar(int idprofe, int idalumne) {

            CitaFormViewModel citaform = new CitaFormViewModel();
            citaform.idAlumne = idalumne;
            citaform.idProfessor = idprofe;
            citaform.NomProfessor = portalParesDomini.getNomProfessorCita(idprofe);
            citaform.NomAlumne = portalParesDomini.getNomFill(idalumne);
            citaform.Comentari = "";
            citaform.Dia = DateTime.Today;
            return PartialView("Citar",citaform);
        }

        
        /* AJAX Handler */

        [HttpPost]
        public ActionResult Citar(CitaFormViewModel cita)
        {
            int idprofessor = cita.idProfessor;
            int idalumne = cita.idAlumne;
            DateTime dia = cita.Dia;
            string comentari = cita.Comentari;
            portalParesDomini.citarProfessor(idprofessor, idalumne, dia, comentari, UserName);
            
            return Json("Ok"); 
        }
        

        [HttpPost]
        public JsonResult  getComentaris(int idavaluacio) {
            string[] comentaris = {"Comentari 1","Comentari 2","Comentari 3"};

            return Json(comentaris);
        }

        private string UserName
        {
            get
            {
                try
                {
                    return User.Identity.Name;
                }
                catch
                {
                    return string.Empty;
                }
            }
        }
        
        
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                portalParesDomini.Dispose();
            }
            base.Dispose(disposing);
        }




        /* Mogut a GestorCitesController : WebApi  */
        //public ActionResult getCitasPare(int PareId, int year, int month) {
        //    System.Threading.Thread.Sleep(400);
        //    IEnumerable<Cita> citas = portalParesDomini.getCitasPare(PareId, year, month).ToList();
        //    var jsonCitas = from cita in citas 
        //                    select new
        //                    {
        //                        id = cita.Id,
        //                        dia = cita.Dia.HasValue ? cita.Dia.Value.ToString("dd/MM/yyyy") : "",
        //                        professor = cita.Professor.Nom + " " + cita.Professor.Cognoms,
        //                        fill = cita.Alumne.Nom + " " + cita.Alumne.Cognoms,
        //                        estat = cita.NomEstat,
        //                        comentari = cita.Comentari
        //                    };


        //    return Json(jsonCitas);
        //}
    }
}
