﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using EscolaMVC.Models;
using EscolaMVC.Services;
using EscolaMVC.Entitats;

namespace EscolaMVC.Controllers
{
    [Authorize(Roles="Professors")]
    public class PortalProfessorController : Controller
    {
        //
        // GET: /PortalProfessor/

        public ActionResult Index()
        {
            PortalProfessors portalprofessordomini = new PortalProfessors();
            PortalProfessorViewModel portal = portalprofessordomini.getPortal(UserName);
            return View(portal);
        }


        public ActionResult guardarNotas(int MatriculaId, int AssignaturaId, string t1, string t2, string t3, string t4) {
            PortalProfessors portalprofessordomini = new PortalProfessors();
            t1 = t1 == "" ? null : t1;
            t2 = t2 == "" ? null : t2;
            t3 = t3 == "" ? null : t3;
            t4 = t4 == "" ? null : t4;
            int idaval = -1;
            if (portalprofessordomini.guardarAvaluacio(MatriculaId, AssignaturaId, t1, t2, t3, t4, out idaval))
            {
                return Json(idaval);
            }
            else {
                return Json("KO");
            }
            
        }

        
        public ActionResult comentarisAvaluacio(int AvaluacioId) {
            PortalProfessors portalprofessordomini = new PortalProfessors();
            var comentaris = portalprofessordomini.getComentarisAvaluacio(AvaluacioId);
            var jsoncomentaris = from comentari in comentaris
                                 select new
                                 {
                                     id = comentari.Id,
                                     comentari = comentari.Comentari,
                                     data = comentari.Data.ToString("dd/MM/yyyy")
                                 };

            return Json(jsoncomentaris, JsonRequestBehavior.AllowGet);
        }


        public ActionResult enviaComentari(int AvaluacioId, string Comentari) {
            PortalProfessors portalprofessordomini = new PortalProfessors();
            ComentariAvaluacio comentari = portalprofessordomini.altaComentari(AvaluacioId, Comentari);
            var unavar = new {
                id = comentari.Id,
                comentari = comentari.Comentari,
                data = comentari.Data.ToString("dd/MM/yyyy")
            };
            return Json(unavar);
        
        }
        public ActionResult eliminaComentari(int ComentariId) {
            PortalProfessors portalprofessordomini = new PortalProfessors();
            portalprofessordomini.eliminarComentari(ComentariId);
            return Json("OK");        
        }



        public ActionResult Citar(int idprofe, int idalumne)
        {
            PortalProfessors portalprofessordomini = new PortalProfessors();
            CitaFormProfessorViewModel citaform = new CitaFormProfessorViewModel();
            citaform.idAlumne = idalumne;
            citaform.idProfessor = idprofe;
            citaform.Pares = portalprofessordomini.getNomPares(idalumne);
            citaform.NomAlumne = portalprofessordomini.getNomAlumne(idalumne);
            citaform.Comentari = "";
            citaform.Dia = DateTime.Today;
            return PartialView("Citar", citaform);
        }


        /* AJAX Handler */

        [HttpPost]
        public ActionResult Citar(CitaFormProfessorViewModel cita)
        {
            PortalProfessors portalprofessordomini = new PortalProfessors();
            int idprofessor = cita.idProfessor;
            int idalumne = cita.idAlumne;
            DateTime dia = cita.Dia;
            string comentari = cita.Comentari;
            portalprofessordomini.citarParesAlumne(idprofessor, idalumne, dia, comentari, UserName);

            return Json("Ok");
        }




        private string UserName
        {
            get
            {
                try
                {
                    return User.Identity.Name;
                }
                catch
                {
                    return string.Empty;
                }
            }
        }

    }
}
