﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Data.Entity;
using System.Globalization;
using System.Web.Mvc;
using System.Web.Security;
using EscolaMVC.Entitats;

namespace EscolaMVC.Models
{
    public class FormulariContacteVM
    {
        private Escola _escola;
        private bool _mostrarForm;

        public FormulariContacteVM()
        {
            this._escola = new Escola();
            this._mostrarForm = true;
        }
        
        public FormulariContacteVM(Escola escola) {
            this._escola = escola;
            this._mostrarForm = true;
        }

        public Escola Escola
        {
            get {
                return this._escola;
            }
        }

        [Display(Name="Nom i cognoms")]
        [Required(ErrorMessage="Has d'introduir el nom i els cognoms")]
        public string NomICognoms
        {
            get;
            set;
        }
        [Required(ErrorMessage = "Camp correu requerit")]
        [DataType(DataType.EmailAddress)]
        [RegularExpression(@"^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,4})$", ErrorMessage = "No és una adreça vàlida.")]
        public  string Correu
        {
            get;
            set;
        }

        [Display(Name = "Assumpte")]
        [Required(ErrorMessage = "Has d'introduir l'assumpte.")]
        [DataType(DataType.MultilineText)]
        public string Assumpte
        {
            get;
            set;
        }
        
        [Display(Name="Cos del missatge")]
        [Required(ErrorMessage="Has d'introduir un missatge.")]
        [DataType(DataType.MultilineText)]
        public string Texte
        {
            get;
            set;
        }

        public string Resposta
        {
            get;
            set;
        }

        public bool MostrarForm
        {
            get { return _mostrarForm; }
            set { _mostrarForm = value; }
        }

        public string Error { get; set; }
    }
}