﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.ComponentModel.DataAnnotations;
using System.Web.Mvc;

namespace EscolaMVC.Models
{
    public class GestioUsuarisModel
    {
        public UsuariPasswordModel UsuariPassword { get; set; }
        public CercaUsuarisModel CercaUsuaris { get; set; }
    }

    public class UsuariPasswordModel
    {

        [Required(ErrorMessage="Nom d'usuari requerit")]
        [Display(Name = "Nom d'usuari")]
        public string UserName { get; set; }

        [StringLength(100, ErrorMessage = "El número de caracteres de {0} debe ser al menos {2}.", MinimumLength = 6)]
        [Display(Name = "Contrasenya")]
        [Required(ErrorMessage="Has d'introduir una contrasenya")]
        public string Contrasenya { get; set; }

        public string Estat { get; set; }

    }

    public class CercaUsuarisModel : IValidatableObject
    {

        public string Usuari { get; set; }
        
        [MaxLength(9, ErrorMessage = "Has d'introduir un DNI NIA valid")]
        public string DNI { get; set; }
        
        public string Nom { get; set; }
        
        public string Cognoms { get; set; }

        [Display(Name = "Tipus")]
        public string Tipus { get; set; }

        public IEnumerable<UsuariModel> Usuaris { get; set; }
        

        

        public IEnumerable<ValidationResult> Validate(ValidationContext validationContext)
        {
            CercaUsuarisModel model = (CercaUsuarisModel)validationContext.ObjectInstance;
            bool totsNul =
                (model.Usuari == null || model.Usuari == string.Empty) &&
                (model.Nom == null || model.Nom == string.Empty) &&
                (model.Cognoms == null || model.Cognoms == string.Empty) &&
                (model.DNI == null || model.DNI == string.Empty);
            if (totsNul)
            {
                yield return new ValidationResult("Has d'introduir algun camp per realitzar la cerca.", new string[]{"CampsNulls"});
                
            }
            
            
        }
    }

    public class UsuariModel {
        public int UserId { get; set; }
        public string UserName { get; set; }
        public string Tipus { get; set; }
        public int Id{get;set;}
        public string DNI { get; set; }
        public string Nom { get; set; }
        public string Cognoms { get; set; }
        public string Sexe { get; set; }
        public string Correu { get; set; }
    
    }
}