﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using EscolaMVC.Entitats;
using System.ComponentModel.DataAnnotations;

namespace EscolaMVC.Models
{
    public class PortalParesViewModel
    {

        public Pare Pare
        {
            get;
            set;
        }

        public bool EsPare{
            get { return this.Pare.Id > 0; }
    
        }

        public bool TeFills {
            get {
                return Fills != null && Fills.Any();
            }
        
        }
        
        public IEnumerable<FillViewModel> Fills
        {
            get;
            set;
        }

        //public IEnumerable<Cita> Citas
        //{
        //    get;
        //    set;
        //}

                
    }

    public class FillViewModel {

        public int Id
        {
            get;
            set;
        }
        
        public string NomiCognoms
        {
            get;
            set;
        }

        public Classe Classe
        {
            get;
            set;
        }

        public IEnumerable<AvaluacioViewModel> Avaluacions
        {
            get;
            set;
        }
    
    }
        

    public class AvaluacioViewModel {

        public int AvaluacioId { get; set; }
        public int? IdProfe { get; set; }
        public string Profe { get; set; }

        public int IdAssig { get; set; }
        public string NomAssignatura { get; set; }
                        
        public decimal? NotaPrimerTrimestre { get; set; }
        public decimal? NotaSegonTrimestre { get; set; }
        public decimal? NotaTercerTrimestre { get; set; }
        public decimal? NotaFinalTrimestre { get; set; }

        public IEnumerable<ComentariAvaluacio> Comentaris { get; set; }

        
    
    }


    
    public class CitaFormViewModel {
        public int idAlumne
        {
            get;
            set;
        }
        public string NomAlumne { get; set; }
        public int idProfessor
        {
            get;
            set;
        }
        public string NomProfessor { get; set; }
        public string NomAssignatura
        {
            get;
            set;
        }
        
        [Required(ErrorMessage="Cal proposar una data.")]    
        public DateTime Dia
        {
            get;
            set;
        }

        [DisplayFormat(ApplyFormatInEditMode = true,DataFormatString = "{0:dd/MM/yyyy}")]
        [Required(ErrorMessage = "Cal introduir algun motiu per la citació.")]    
        public string Comentari
        {
            get;
            set;
        }
    
    }

    public class CitaFormProfessorViewModel
    {
        public int idAlumne
        {
            get;
            set;
        }
        public string NomAlumne { get; set; }
        public int idProfessor
        {
            get;
            set;
        }
        public string[] Pares { get; set; }
        public string NomAssignatura
        {
            get;
            set;
        }

        [Required(ErrorMessage = "Cal proposar una data.")]
        public DateTime Dia
        {
            get;
            set;
        }

        [DisplayFormat(ApplyFormatInEditMode = true, DataFormatString = "{0:dd/MM/yyyy}")]
        [Required(ErrorMessage = "Cal introduir algun motiu per la citació.")]
        public string Comentari
        {
            get;
            set;
        }

    }


}