using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Linq.Expressions;
using System.Web;
using EscolaMVC.Entitats;

namespace EscolaMVC.Models
{ 
    public class CursRepository : ICursRepository
    {
        EscolaEntities context = new EscolaEntities();

        public IQueryable<Curs> All
        {
            get { return context.Curs; }
        }

        public IQueryable<Curs> AllIncluding(params Expression<Func<Curs, object>>[] includeProperties)
        {
            IQueryable<Curs> query = context.Curs;
            foreach (var includeProperty in includeProperties) {
                query = query.Include(includeProperty);
            }
            return query;
        }

        public Curs Find(int id)
        {
            return context.Curs.Find(id);
        }

        public void InsertOrUpdate(Curs curs)
        {
            if (curs.Id == default(int)) {
                // New entity
                context.Curs.Add(curs);
            } else {
                // Existing entity
                context.Entry(curs).State = EntityState.Modified;
            }
        }

        public void Delete(int id)
        {
            var curs = context.Curs.Find(id);
            context.Curs.Remove(curs);
        }

        public void Save()
        {
            context.SaveChanges();
        }

        public void Dispose() 
        {
            context.Dispose();
        }
    }

    public interface ICursRepository : IDisposable
    {
        IQueryable<Curs> All { get; }
        IQueryable<Curs> AllIncluding(params Expression<Func<Curs, object>>[] includeProperties);
        Curs Find(int id);
        void InsertOrUpdate(Curs curs);
        void Delete(int id);
        void Save();
    }
}