﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using EscolaMVC.Models;

namespace EscolaMVC.Entitats
{
    public class CercaUsuarisDb
    {

        public IEnumerable<UsuariModel> cercaUsuaris(string usuari, string dni, string nom, string cognoms, string tipus)
        {
            string[] tipusValids = EscolaMVC.Entitats.TipusUsuaris.Tipus;
            if(!tipusValids.Contains(tipus)) return null;
            string vista = tipus;
            EscolaEntities ctx = new EscolaEntities();
            string cercaUsuariSQL = string.Format(@"Select * from Usuari{0}View Where UserName = @usuari",vista);
            string cercaUDNISQL = string.Format(@"Select * from Usuari{0}View Where DNI = @DNI", vista);
            string cercaNom = string.Format(@"Select * from Usuari{0}View Where Nom Like @nom AND Cognoms Like @cognoms", vista);
            if (usuari != null)
            {
                var usuaris = ctx.Database.SqlQuery<UsuariModel>(cercaUsuariSQL, new System.Data.SqlClient.SqlParameter("usuari", usuari));
                return usuaris.ToList();
            }
            if (dni != null)
            {
                var usuaris = ctx.Database.SqlQuery<UsuariModel>(cercaUDNISQL, new System.Data.SqlClient.SqlParameter("dni", dni));
                return usuaris.ToList();
            }
            if (nom != null || cognoms != null) {
                nom = nom?? "%";
                cognoms = cognoms ?? "%";
                var usuaris = ctx.Database.SqlQuery<UsuariModel>(cercaNom, 
                    new System.Data.SqlClient.SqlParameter("nom", nom), 
                    new System.Data.SqlClient.SqlParameter("cognoms", cognoms)
                );
                return usuaris.ToList();
            }
            return null;
           
        }
        
        
        

    }
}