﻿/// <reference path="jquery-1.7.1-vsdoc.js" />
/// <reference path="jquery-ui-1.10.3.js" />
$(document).ready(function () {
    $.ajaxSetup({ cache: false }); /* No volem cache!! */
});

var visibleYear; /* dates visibles al datepicker */
var visibleMonth;



var Cita = function (id, dia, professor, fill, comentari, estat, historic) {
    this.id = id;
    this.dia = dia;
    this.comentari = comentari;
    this.professor = professor;
    this.fill = fill;
    this.estat = estat;
    this.historic = historic;

};

var Citas = {};

function jsonToCita(jsonData) {
    var cita = new Cita(jsonData.id, jsonData.dia, jsonData.professor, jsonData.fill, jsonData.comentari, jsonData.estat, jsonData.historic);
    return cita;

}

function fillArrayCitas(data) {
    $("#citas").html("");
    $.each(data, function () {
        var unacita = jsonToCita(this);
        Citas[unacita.dia] = unacita;
        insertarCitasDiv(unacita);
    });
}



function recuperarCitas(year, month) {
    loading();
    var idpare = $("#idpare").val();
    var year = year;
    var month = month;
    if (!year && !month) {
        var avui = new Date();
        year = avui.getFullYear();
        month = avui.getMonth();
        month = month + 1;

        visibleYear = year;
        visibleMonth = month;

    }

    $.getJSON(urlApiGetCitas, {
        PareId: idpare,
        year: year,
        month: month
    }, function (data) {
        fillArrayCitas(data);
        loaded();
        $("#calendari").datepicker({
            onChangeMonthYear: canviaMes,
            beforeShowDay: setDates
        });
    }).error(function () {
        loaded();
        alert("Error en la comunicació.");
    });
}




/* UI */

function loading() { $("#jQcircles").removeClass("hiden"); }
function loaded() { $("#jQcircles").addClass("hiden"); }

/* Montamos el div con las citas recuperadas. */

/* Estats cita: PendentProfessor,PendentPare,Acceptada,CanceladaPare,CanceladaProfessor,RebutjadaPare,RebutjadaProfessor  */
function insertarCitasDiv(unacita) {
    var citali = $("<div class='unacita' id='cita"+unacita.id+"'></div>");
    $(citali).append("<div><b>" + unacita.dia + " amb " + unacita.professor + "</b></div>");
    $(citali).append("<div><b>Alumne: </b>" + unacita.fill + "</div>");
    $(citali).append("<div class='cmntcita'>" + unacita.comentari + "</div>");

    if (unacita.estat == "PendentProfessor") {
        $(citali).append("<div class='Estat" + unacita.estat + "'><b>Estat:</b> Pendent d'aprovació.</div>");
        $(citali).append("<a href='#' class='eliminarCitalink' id='delcita" + unacita.id + "'>Elimina cita</a>");
    }
    if (unacita.estat == "PendentPare") {
        $(citali).append("<span class='Estat" + unacita.estat + "'><b>Estat:</b> Vols acceptar aquesta cita?</div>");
        $(citali).append("<a href='#' class='acceptarCitalink' id='okcita" + unacita.id + "'>Accepta cita</a> | ");
        $(citali).append("<a href='#' class='rebutjarCitalink' id='rbcita" + unacita.id + "'>Rebutja cita</a>");
    }
    if (unacita.estat == "Acceptada") {
        $(citali).append("<div class='Estat" + unacita.estat + "'><b>Estat:</b> " + unacita.estat + "</div>");
        $(citali).append("<a href='#' class='cancelarCitalink' id='clcita" + unacita.id + "'>Anul·la cita</a>");
    }
    if (unacita.estat == "CanceladaPare") {
        $(citali).append("<div class='Estat" + unacita.estat + "'><b>Estat:</b> Has cancel·lat aquesta cita.</div>");
    }
    if (unacita.estat == "CanceladaProfessor") {
        $(citali).append("<div class='Estat" + unacita.estat + "'><b>Estat:</b> El professor/a ha cancel·lat la cita.</div>");
        $(citali).append("<a href='#' class='eliminarCitalink' id='delcita" + unacita.id + "'>Elimina cita</a>");
    }
    if (unacita.estat == "RebutjadaPare") {
        $(citali).append("<div class='Estat" + unacita.estat + "'><b>Estat:</b> Has rebutjat aquesta cita.</div>");
    }
    if (unacita.estat == "RebutjadaProfessor") {
        $(citali).append("<div class='Estat" + unacita.estat + "'><b>Estat:</b> El professor ha rebutjat aquesta cita.</div>");
        $(citali).append("<a href='#' class='eliminarCitalink' id='delcita" + unacita.id + "'>Elimina cita</a>");
    }
    $(citali).append("<a href='#' title='"+unacita.historic+"' class='detallsCitalink' id='dtcita" + unacita.id + "'>+ Detalls</a>");
    $("#citas").append(citali);
}











    /* Citas click binding links */

    function actualizarCitas() {
        Citas = {};
        $("#calendari").datepicker("destroy"); 
        recuperarCitas(visibleYear, visibleMonth);
     }

    /* Eliminar cita */
     $("#citas").on("click", ".eliminarCitalink",
        function (event) {
            event.preventDefault();
            var idcita = $(this).attr("id").substring(7);
            if (confirm("Estàs segur")) {
                eliminarCita(idcita);
            }
        });

    function eliminarCita(idcita) {
        loading();
        $.ajax({
            type: "DELETE",
            url: urlEliminarCita + idcita
        }).done(function (data) {
            actualizarCitas();
            loaded();
        }).fail(function () { alert("Error en les comunicacions"); loaded(); });

    }

    /* Acceptar cita */
    function acceptarCita(idcita) {
        loading();
        $.ajax({ type: "GET", url: urlAcceptarCita,
            data: { id: idcita}
        }).done(function (data) {
                actualizarCitas();
                loaded();
            }).fail(function () {
                alert("Error en les comunicacions"); loaded(); 
            });
        
    }

    $("#citas").on("click", ".acceptarCitalink",
    function (event) {
        event.preventDefault();
        var idcita = $(this).attr("id").substring(6);
        acceptarCita(idcita);
    });


    /* Cancelar cita */
    function cancelarCita(idcita) {
        loading();
        var motiusrebutja = $("#motiusCancel").val();
        $.ajax({ type: "GET", url: urlCancelarCita,
            data: { id: idcita, motius: motiusrebutja }
        }).done(function (data) {
            actualizarCitas();
            loaded();
        }).fail(function () {
            alert("Error en les comunicacions"); loaded();
        });

    }

    $("#citas").on("click", ".cancelarCitalink",
    function (event) {
        event.preventDefault();
        var idcita = $(this).attr("id").substring(6);
        $(".cancelaCitaDialog").dialog({ modal: true, width: 600, height: 400,
            buttons: {
                "Anul·lar": function () { $(this).dialog("close"); cancelarCita(idcita); },
                "Cancel·lar": function () { $(this).dialog("close"); }
            }
        });
    });

    /*Rebuthar Cita*/
    function rebutjarCita(idcita) {
        var motiusrebutja = $("#motiusCancel").val();
        $("#motiusCancel").val("");
        loading();
        $.ajax({ type: "GET", url: urlRebutjarCita,
            data: { id: idcita, motius : motiusrebutja }
        }).done(function (data) {
            actualizarCitas();
            loaded();
        }).fail(function () {
            alert("Error en les comunicacions"); loaded();
        });

    }

    $("#citas").on("click", ".rebutjarCitalink",
    function (event) {
        event.preventDefault();
        var idcita = $(this).attr("id").substring(6);
        $(".cancelaCitaDialog").dialog({ modal: true, width: 600, height: 400,
            buttons: {
                "Rebutjar": function () { $(this).dialog("close"); rebutjarCita(idcita); },
                "Cancel·lar": function(){$(this).dialog("close");}
            }
        });

    });

    /* Detalls cita */

    $("#citas").on("click", ".detallsCitalink",
    function (event) {
        event.preventDefault();
        var idcita = $(this).attr("id").substring(6);
        var historic = $(this).attr("title");
        var comentari_cita = $(".cmntcita", "#cita" + idcita).text();

        $("#detallsComentari").text(comentari_cita);
        $("#historiccita").text(historic);
        $(".historicCita").dialog({ modal: true, width: 600, height: 400,
            buttons: {
                "Tanca": function () {
                    $("#historiccita").text("");
                    $(this).dialog("close");
                }
            }
        });

    });


/* Estats cita: PendentProfessor,PendentPare,Acceptada,CanceladaPare,CanceladaProfessor,RebutjadaPare,RebutjadaProfessor  */
function setDates(date) {
    var diacita = $.datepicker.formatDate("dd/mm/yy", date);
    var cita = Citas[diacita];
    if (cita) {
            return [true, 'jQCita '+cita.estat, cita.comentari];
    }
    else {
        return [true,'' ];
    }
}

function canviaMes(year, month) {
    visibleYear = year;
    visibleMonth = month;
    recuperarCitas(year,month);

}


$(function () {
    recuperarCitas();
});




function ajaxizarFormCita() {
    $("#Dia", ".citaFormNou").datepicker();

    $("form", '.citaFormNou').submit(function (e) {
        $.validator.unobtrusive.parse($(this));
        e.preventDefault();
        if (!$(this).valid()) return false;
        $.post($(this).attr("action"), $(this).serialize(), function (resultat) {
            if (resultat == "Ok") {
                $(".citaDiv").dialog("close");
                $(".cancelCitabt").click();
                $("#resutatCrear").text("Cita enregistrada correctament");
                $("#resutatCrear").attr("title", "Resultat");
                $("#resutatCrear").dialog({ modal: true,
                    beforeClose: function (event, ui) { actualizarCitas(); }
                });
                
            }

        });
    });
}

$(function () {
    $(".citarBt").click(function (event) {
        event.preventDefault();
        $.ajax({
            url: this.href,
            success: function (result) {
                $(".citaDiv").html(result);
                $(".citaDiv").dialog({ width: 700, height: 400 });
                ajaxizarFormCita();
            }
        });
    });
});


$(function () {
    $(".cancelCitabt").live("click", null, function () {
        $(".citaDiv").dialog("close");
        $(".citaDiv").html("");

    });
});



$(function () {
    $(".togleNotas").click(function (event) {
        event.preventDefault();
        var notesId = $(this).attr("href");
        $(notesId).toggle(300);
    });
});

$(function () {
    $(".avaluacio_comentaris").toggle();
    $(".mostraComentaris").click(function (event) {
        event.preventDefault();
        var url = $(this).attr("href");
        var idaval = $(this).attr("title");
        var idcomentaris = "#comentaris_avaluacio_" + idaval;
        $(idcomentaris).toggle();

        //            var resultat = $("<ul></ul>");
        //            $.post(url, { id: idaval }, function (data) {
        //                $(data).each(function (i, item) {
        //                    $(resultat).append("<li class='un_comentari'>" + item + "</li>");
        //                });
        //            }).fail(function () {
        //                $(resultat).html("<li class='error'>Error al recuperar les dades</li>");
        //            }).always(function () {
        //                $(idcomentaris).html("");
        //                $(idcomentaris).append(resultat);
        //                $(idcomentaris).toggle();
        //            });
        

    });
});


/* recuperarCitas desde controlador no API */
//function recuperarCitas(year, month) {
//    loading();
//    //var urlgetCitas = $("#urlgetCitas").attr("href");
//    var idpare = $("#idpare").val();
//    var year = year;
//    var month = month;
//    if (!year && !month) {
//        var avui = new Date();
//        year = avui.getFullYear();
//        month = avui.getMonth();
//        month = month + 1;
//    }
//    
//    $.post(urlgetCitas, {
//        PareId: idpare,
//        year: year,
//        month: month
//    }, function (data) {
//        fillArrayCitas(data);
//        loaded();
//        $("#calendari").datepicker({
//            onChangeMonthYear: canviaMes,
//            beforeShowDay: setDates
//        });
//    }).error(function () {
//        loaded();
//        alert("Error en la comunicació.");
//    });
//}
