﻿/// <reference path="jquery-1.7.1-vsdoc.js" />
/// <reference path="jquery-ui-1.10.3.js" />
$(document).ready(function () {
    $.ajaxSetup({ cache: false }); /* No volem cache!! */
});

function loading() { $("#jQcircles").removeClass("hiden"); }
function loaded() { $("#jQcircles").addClass("hiden"); }


/************************* 
    Docencia y Notas 
*************************/

$(function () {
    $(".prtProf_classe").hide();
});

$(".prtProf_seleccio_docencia").on("click", ".prtProf_mostrar_doc",
    function (event) {
        event.preventDefault();
        var idclasse = $(this).attr("href");
        $(".prtProf_classe").hide();
        $("#"+idclasse, ".prtProf_classes_container").show();
    });


    $(".prtProf_alumne_container").on("change", ".prtProf_nota", function (event) {
        $(this).addClass("changed");
    });



    $(".prtProf_alumne_container").on("click", ".prtProf_comentarNotas", function (event) {
        event.preventDefault();
        loading();
        $matricula = $(this).parent().parent();
        var idaval = $(".prtProf_idcoment", $matricula).val();
        $("#aval_id").val(idaval);
        $(".prtProf_comentaris_llista").children().remove();
        getComentaris(idaval);
        loaded();
    });

    function getComentaris(idaval) {
        $.getJSON(urlgetAval, { AvaluacioId: idaval }, function (data) {
            $(data).each(function (i, item) {
                $uncomentari = $("<div class='prtProf_uncomentari' id='" + item.id + "'>" + item.data + ": " + item.comentari + " <a href='#' class='prtProf_eliminarCmnt'>Elimina</a></div>");
                $(".prtProf_comentaris_llista").append($uncomentari);
            });
            $(".prtProf_comentaris").dialog({ width: 600 });
        });
    }



    /* Afegir comentari */
    $(".prtProf_comentaris").on("click", ".prtProf_enviar_comentari", function (event) {
        event.preventDefault();
        var idavaluacio = $("#aval_id").val();
        var comentari = $("#noucomentari").val();

        $.post(urlEnviaComentari, { AvaluacioId: idavaluacio, Comentari: comentari }, function (data) {
            var item = data;
            $uncomentari = $("<div class='prtProf_uncomentari' id='" + item.id + "'>" + item.data + ": " + item.comentari + " <a href='#' class='prtProf_eliminarCmnt'>Elimina</a></div>");
            $(".prtProf_comentaris_llista").append($uncomentari);
            $("#noucomentari").val("");
        });

    });
    
    /* Eliminar comentari */
    $(".prtProf_comentaris").on("click", ".prtProf_eliminarCmnt", function (event) {
        event.preventDefault();
        var idcomentari = $(this).parent().attr("id");
        $.post(urlEliminaComentari, { ComentariId: idcomentari },
            function (data) {
                if (data == "OK") {
                    $(".prtProf_uncomentari#" + idcomentari).remove();
                }
            }
        );

    });


    $(".prtProf_alumne_container").on("click", ".prtProf_guardaNotas",
    function (event) {
        event.preventDefault();
        loading();
        $matricula = $(this).parent().parent();
        var idmatricula = $(this).parent().parent().attr("id").substring(9);
        var idassignatura = $(this).attr("href");
        var t1, t2, t3, t4;
        t1 = $("input[name=t1]", $matricula).val();
        t2 = $("input[name=t2]", $matricula).val();
        t3 = $("input[name=t3]", $matricula).val();
        t4 = $("input[name=t4]", $matricula).val();

        $.ajax({
            type: "POST",
            url: urlGuardarNotas,
            data: { MatriculaId: idmatricula,
                AssignaturaId: idassignatura,
                t1: t1,
                t2: t2,
                t3: t3,
                t4: t4
            }
        }).done(function (data) {
            loaded();
            if (data >= 1) {
                $(".prtProf_nota", $matricula).removeClass("changed");
                $(".prtProf_idcoment", $matricula).val(data);
                $("#aval_id").val(data);
            }
            if (data == -1) {
                alert("Error al guardar els canvis");
            }
            if (data == "KO") {
                alert("Error al guardar els canvis");
            }
        }).fail(function () { alert("Error en les comunicacions."); loaded(); });


    });


   /*********************
    *   Gestor de Citas  * 
    **********************/
//    $(function () {
//        $("#prtProf_calendari").datepicker();
//     });


    var visibleYear; /* dates visibles al datepicker */
    var visibleMonth;

    /*
          id;dia;string[] pares,alumne,estat;comentari;historic;

*/
    var Cita = function (id, dia, pares, alumne, comentari, estat, historic) {
        this.id = id;
        this.dia = dia;
        this.comentari = comentari;
        this.alume = alumne;
        this.pares = pares;
        this.estat = estat;
        this.historic = historic;
    };

    var Citas = {};

   
    function fillArrayCitas(data) {
        $("#prtProf_llista_cites").html("");
        $.each(data, function () {
            Citas[this.dia] = this;
            var citali = $("<div class='unacita' id='cita" + this.id + "'></div>");
            $(citali).append("<div><b>" + this.dia + " amb " + this.alumne + "</b></div>");
            $(citali).append("<div><b>Pares: </b>" + this.pares + "</div>");
            $(citali).append("<div class='cmntcita'>" + this.comentari + "</div>");

            if (this.estat == "PendentPare") {
                $(citali).append("<div class='Estat" + this.estat + "'><b>Estat:</b> Pendent d'aprovació.</div>");
                $(citali).append("<a href='#' class='eliminarCitalink' id='delcita" + this.id + "'>Elimina cita</a>");
            }
            if (this.estat == "PendentProfessor") {
                $(citali).append("<span class='Estat" + this.estat + "'><b>Estat:</b>Pendent: </div>");
                $(citali).append("<a href='#' class='acceptarCitalink' id='okcita" + this.id + "'>Accepta cita</a> | ");
                $(citali).append("<a href='#' class='rebutjarCitalink' id='rbcita" + this.id + "'>Rebutja cita</a>");
            }
            if (this.estat == "Acceptada") {
                $(citali).append("<div class='Estat" + this.estat + "'><b>Estat:</b> " + this.estat + "</div>");
                $(citali).append("<a href='#' class='cancelarCitalink' id='clcita" + this.id + "'>Anul·la cita</a>");
            }
            if (this.estat == "CanceladaProfessor") {
                $(citali).append("<div class='Estat" + this.estat + "'><b>Estat:</b>Has cancel·lat aquesta cita.</div>");
            }
            if (this.estat == "CanceladaPare") {
                $(citali).append("<div class='Estat" + this.estat + "'><b>Estat:</b> El pare ha cancel·lat la cita.</div>");
                $(citali).append("<a href='#' class='eliminarCitalink' id='delcita" + this.id + "'>Elimina cita</a>");
            }
            if (this.estat == "RebutjadaProfessor") {
                $(citali).append("<div class='Estat" + this.estat + "'><b>Estat:</b> Has rebutjat aquesta cita.</div>");
            }
            if (this.estat == "RebutjadaPare") {
                $(citali).append("<div class='Estat" + this.estat + "'><b>Estat:</b> El pare ha rebutjat la cita.</div>");
                $(citali).append("<a href='#' class='eliminarCitalink' id='delcita" + this.id + "'>Elimina cita</a>");
            }
            $(citali).append("<a href='#' title='" + this.historic + "' class='detallsCitalink' id='dtcita" + this.id + "'>+ Detalls</a>");
            $("#prtProf_llista_cites").append(citali);

        });
    }
    function recuperarCitas(year, month) {
        loading();
        var idprofessor = $("#ProfessorId").val();
        var year = year;
        var month = month;
        if (!year && !month) {
            var avui = new Date();
            year = avui.getFullYear();
            month = avui.getMonth();
            month = month + 1;

            visibleYear = year;
            visibleMonth = month;

        }

        $.getJSON(urlApiGetCitas, {
            ProfessorId: idprofessor,
            year: year,
            month: month
        }, function (data) {
            fillArrayCitas(data);
            loaded();
            $("#prtProf_calendari").datepicker({
                onChangeMonthYear: canviaMes,
                beforeShowDay: setDates
            });
        }).error(function () {
            loaded();
            alert("Error en la comunicació.");
        });
    }

    function actualizarCitas() {
        Citas = {};
        $("#prtProf_calendari").datepicker("destroy");
        recuperarCitas(visibleYear, visibleMonth);
    }

    function setDates(date) {
        var diacita = $.datepicker.formatDate("dd/mm/yy", date);
        var cita = Citas[diacita];
        if (cita) {
            return [true, 'jQCita ' + cita.estat, cita.comentari];
        }
        else {
            return [true, ''];
        }
    }

    function canviaMes(year, month) {
        visibleYear = year;
        visibleMonth = month;
        recuperarCitas(year, month);

    }
    
    $(function () {
        recuperarCitas();
    });


    /* Eliminar cita */
    $("#prtProf_llista_cites").on("click", ".eliminarCitalink",
        function (event) {
            event.preventDefault();
            var idcita = $(this).attr("id").substring(7);
            if (confirm("Estàs segur")) {
                eliminarCita(idcita);
            }
        });

    function eliminarCita(idcita) {
        loading();
        $.ajax({
            type: "DELETE",
            url: urlEliminarCita + idcita
        }).done(function (data) {
            actualizarCitas();
            loaded();
        }).fail(function () { alert("Error en les comunicacions"); loaded(); });

    }

    /* Acceptar cita */
    function acceptarCita(idcita) {
        loading();
        $.ajax({ type: "GET", url: urlAcceptarCita,
            data: { id: idcita }
        }).done(function (data) {
            actualizarCitas();
            loaded();
        }).fail(function () {
            alert("Error en les comunicacions"); loaded();
        });

    }

    $("#prtProf_llista_cites").on("click", ".acceptarCitalink",
    function (event) {
        event.preventDefault();
        var idcita = $(this).attr("id").substring(6);
        acceptarCita(idcita);
    });


    /* Cancelar cita */
    function cancelarCita(idcita) {
        loading();
        var motiusrebutja = $("#motiusCancel").val();
        $.ajax({ type: "GET", url: urlCancelarCita,
            data: { id: idcita, motius: motiusrebutja }
        }).done(function (data) {
            actualizarCitas();
            loaded();
        }).fail(function () {
            alert("Error en les comunicacions"); loaded();
        });

    }

    $("#prtProf_llista_cites").on("click", ".cancelarCitalink",
    function (event) {
        event.preventDefault();
        var idcita = $(this).attr("id").substring(6);
        $(".cancelaCitaDialog").dialog({ modal: true, width: 600, height: 400,
            buttons: {
                "Anul·lar": function () { $(this).dialog("close"); cancelarCita(idcita); },
                "Cancel·lar": function () { $(this).dialog("close"); }
            }
        });
    });

    /*Rebuthar Cita*/
    function rebutjarCita(idcita) {
        var motiusrebutja = $("#motiusCancel").val();
        $("#motiusCancel").val("");
        loading();
        $.ajax({ type: "GET", url: urlRebutjarCita,
            data: { id: idcita, motius: motiusrebutja }
        }).done(function (data) {
            actualizarCitas();
            loaded();
        }).fail(function () {
            alert("Error en les comunicacions"); loaded();
        });

    }

    $("#prtProf_llista_cites").on("click", ".rebutjarCitalink",
    function (event) {
        event.preventDefault();
        var idcita = $(this).attr("id").substring(6);
        $(".cancelaCitaDialog").dialog({ modal: true, width: 600, height: 400,
            buttons: {
                "Rebutjar": function () { $(this).dialog("close"); rebutjarCita(idcita); },
                "Cancel·lar": function () { $(this).dialog("close"); }
            }
        });

    });

    /* Detalls cita */

    $("#prtProf_llista_cites").on("click", ".detallsCitalink",
    function (event) {
        event.preventDefault();
        var idcita = $(this).attr("id").substring(6);
        var historic = $(this).attr("title");
        var comentari_cita = $(".cmntcita", "#cita" + idcita).text();

        $("#detallsComentari").text(comentari_cita);
        $("#historiccita").text(historic);
        $(".historicCita").dialog({ modal: true, width: 600, height: 400,
            buttons: {
                "Tanca": function () {
                    $("#historiccita").text("");
                    $(this).dialog("close");
                }
            }
        });

    });


    /*  Alta Cita */
    $(function () {
        $(".citarBt").click(function (event) {
            event.preventDefault();
            $.ajax({
                url: this.href,
                success: function (result) {
                    $(".citaDiv").html(result);
                    $(".citaDiv").dialog({ width: 700, height: 500 });
                    ajaxizarFormCita();
                }
            });
        });
    });

    function ajaxizarFormCita() {
        $("#Dia", ".citaFormNou").datepicker();

        $("form", '.citaFormNou').submit(function (e) {
            $.validator.unobtrusive.parse($(this));
            e.preventDefault();
            if (!$(this).valid()) return false;
            $.post($(this).attr("action"), $(this).serialize(), function (resultat) {
                if (resultat == "Ok") {
                    $(".citaDiv").dialog("close");
                    $(".cancelCitabt").click();
                    $("#resutatCrear").text("Cita enregistrada correctament");
                    $("#resutatCrear").attr("title", "Resultat");
                    $("#resutatCrear").dialog({ modal: true,
                        beforeClose: function (event, ui) { actualizarCitas(); }
                    });

                }

            });
        });
    }

